grails-app/domain/jobs/Usuario.groovy
package jobs

class Usuario {

    Long id
    String correo
    String contrasenia
    String nombre
    String apellido
    Date fechaCreacion = new Date()
    Boolean esTrabajador

    static mapping = {
        id column: "id", type: "long", sqlType: "int", generator: 'identity'
        version false
    }
    static constraints = {
        fechaCreacion display: false
        correo email: true

    }
}

grails-app/controllers/jobs/UsuarioController.groovy
package jobs

import grails.validation.ValidationException
import org.springframework.security.core.authority.SimpleGrantedAuthority
import org.springframework.security.core.userdetails.User
import org.springframework.security.core.userdetails.UserDetails
import org.springframework.security.provisioning.UserDetailsManager

import static org.springframework.http.HttpStatus.*

class UsuarioController {

    UsuarioService usuarioService
    UserDetailsManager userDetailsService


    static allowedMethods = [save: "POST", update: "PUT", delete: "DELETE"]

    def index(Integer max) {
        params.max = Math.min(max ?: 10, 100)
        respond usuarioService.list(params), model:[usuarioCount: usuarioService.count()]
    }

    def show(Long id) {
        respond usuarioService.get(id)
    }

    def showVersion2(Long id) {
        Usuario user = usuarioService.findByCorreo(session.SPRING_SECURITY_CONTEXT.authentication.principal.username)
        respond usuarioService.get(user.id)
    }

    def create() {
        respond new Usuario(params)
    }


    def save(Usuario usuario) {
        if (usuario == null) {
            notFound()
            return
        }

        try {
            usuario.fechaCreacion = new Date()
            usuario.esTrabajador = false
            usuarioService.save(usuario)

            def rol
            if(usuario.esTrabajador == true)
                rol = "TRABAJADOR"
            else
                rol = "CLIENTE"
            UserDetails userDetail = new User(usuario.getCorreo(), usuario.getContrasenia(),  [new SimpleGrantedAuthority(rol)])

            //userDetailsService.createUser(new User(it.getCorreo(), it.getContrasenia(), [new SimpleGrantedAuthority(rol)]))
            userDetailsService.createUser( userDetail)

        } catch (ValidationException e) {
            respond usuario.errors, view:'create'
            return
        }

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.created.message', args: [message(code: 'usuario.label', default: 'Usuario'), usuario.id])
                redirect usuario
            }
            '*' { respond usuario, [status: CREATED] }
        }
    }

    def edit(Long id) {
        respond usuarioService.get(id)
    }

    def update(Usuario usuario) {
        if (usuario == null) {
            notFound()
            return
        }

        try {
            usuarioService.save(usuario)
        } catch (ValidationException e) {
            respond usuario.errors, view:'edit'
            return
        }

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.updated.message', args: [message(code: 'usuario.label', default: 'Usuario'), usuario.id])
                redirect usuario
            }
            '*'{ respond usuario, [status: OK] }
        }
    }

    def delete(Long id) {
        if (id == null) {
            notFound()
            return
        }

        usuarioService.delete(id)

        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.deleted.message', args: [message(code: 'usuario.label', default: 'Usuario'), id])
                redirect action:"index", method:"GET"
            }
            '*'{ render status: NO_CONTENT }
        }
    }

    protected void notFound() {
        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.not.found.message', args: [message(code: 'usuario.label', default: 'Usuario'), params.id])
                redirect action: "index", method: "GET"
            }
            '*'{ render status: NOT_FOUND }
        }
    }
}

grails-app/views/usuario/create.gsp
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'usuario.label', default: 'Usuario')}" />
        <title><g:message code="default.create.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#create-usuario" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
            </ul>
        </div>
        <div id="create-usuario" class="content scaffold-create" role="main">
            <h1><!--<g:message code="default.create.label" args="[entityName]" />-->Regístrate en Real Services</h1>
            <g:if test="${flash.message}">
            <div class="message" role="status">${flash.message}</div>
            </g:if>
            <g:hasErrors bean="${this.usuario}">
            <ul class="errors" role="alert">
                <g:eachError bean="${this.usuario}" var="error">
                <li <g:if test="${error in org.springframework.validation.FieldError}">data-field-id="${error.field}"</g:if>><g:message error="${error}"/></li>
                </g:eachError>
            </ul>
            </g:hasErrors>
            <g:form resource="${this.usuario}" method="POST">
                <fieldset class="form">
                    <f:field bean="usuario" property="nombre" />
                    <f:field bean="usuario" property="apellido" />
                    <f:field bean="usuario" property="correo" />
                    <f:field bean="usuario" property="contrasenia" />
                </fieldset>
                <fieldset class="buttons">
                    <g:submitButton name="create" class="save" value="Registrarme" />
                </fieldset>
            </g:form>
        </div>
    </body>
</html>

grails-app/views/usuario/edit.gsp
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'usuario.label', default: 'Usuario')}" />
        <title><g:message code="default.edit.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#edit-usuario" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
                <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
            </ul>
        </div>
        <div id="edit-usuario" class="content scaffold-edit" role="main">
            <h1><g:message code="default.edit.label" args="[entityName]" /></h1>
            <g:if test="${flash.message}">
            <div class="message" role="status">${flash.message}</div>
            </g:if>
            <g:hasErrors bean="${this.usuario}">
            <ul class="errors" role="alert">
                <g:eachError bean="${this.usuario}" var="error">
                <li <g:if test="${error in org.springframework.validation.FieldError}">data-field-id="${error.field}"</g:if>><g:message error="${error}"/></li>
                </g:eachError>
            </ul>
            </g:hasErrors>
            <g:form resource="${this.usuario}" method="PUT">
                <g:hiddenField name="version" value="${this.usuario?.version}" />
                <fieldset class="form">
                    <f:all bean="usuario"/>
                </fieldset>
                <fieldset class="buttons">
                    <input class="save" type="submit" value="${message(code: 'default.button.update.label', default: 'Update')}" />
                </fieldset>
            </g:form>
        </div>
    </body>
</html>

grails-app/views/usuario/index.gsp
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'usuario.label', default: 'Usuario')}" />
        <title><g:message code="default.list.label" args="[entityName]" /></title>
    </head>
    <body>
    <content tag="nav">
                <li class="dropdown">
                        <a href="#" aria-haspopup="true" aria-expanded="false">

                <g:form controller="servicio" action="indexList" method="post">
                    <g:textField id="mytext" name="nombre" placeholder="Busca un servicio" value="${nombre}" role="button" aria-haspopup="true" aria-expanded="false" style="margin-top: 15px"/>
                    <button id="submit-values" class="btn btn-small btn-primary" type="submit">
                        <i class="icon-ok"></i>
                        Buscar
                    </button>
                </g:form>
                <span class="caret"></span></a>
                </li>

                <!-- <li class="dropdown">
                    <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Aqui va el buscador <span class="caret"></span></a>
                    <ul class="dropdown-menu">
                        <li class="dropdown-item"><a href="#">Environment: ${grails.util.Environment.current.name}</a></li>
                        <li class="dropdown-item"><a href="#">App profile: ${grailsApplication.config.grails?.profile}</a></li>
                        <li class="dropdown-item"><a href="#">App version:
                            <g:meta name="info.app.version"/></a>
                        </li>
                        <li role="separator" class="dropdown-divider"></li>
                        <li class="dropdown-item"><a href="#">Grails version:
                            <g:meta name="info.app.grailsVersion"/></a>
                        </li>
                        <li class="dropdown-item"><a href="#">Groovy version: ${GroovySystem.getVersion()}</a></li>
                        <li class="dropdown-item"><a href="#">JVM version: ${System.getProperty('java.version')}</a></li>
                        <li role="separator" class="dropdown-divider"></li>
                        <li class="dropdown-item"><a href="#">Reloading active: ${grails.util.Environment.reloadingAgentEnabled}</a></li>
                    </ul>
                </li> -->
                <li class="dropdown">
                    <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Perfil <span class="caret"></span></a>
                    <ul class="dropdown-menu">
            			<!-- <li class="controller">
            				<g:link controller="Usuario" action="show">Ir a mi perfil</g:link>
            			</li> -->
                        <li class="controller">
            				<g:link controller="Login">Inicia Sesión</g:link>
            			</li>
            			<li class="controller">
            				<g:link controller="Usuario">Ver Perfil</g:link>
            			</li>
            			<li class="controller">
            				<g:link controller="Logout">Cerrar Sesión</g:link>
            			</li>
                    </ul>
                </li>
            	<li class="dropdown">
            		<li class="controller">
            			<g:link controller="Usuario" action="create" style="margin-top: 20px">Regístrate</g:link>
            		</li>
            	</li>
                <li class="dropdown">
                    <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Administrador <span class="caret"></span></a>
                    <ul class="dropdown-menu">
            				<li class="controller">
            					<g:link controller="Categoria">Categoria</g:link>
            				</li>
            				<li class="controller">
            					<g:link controller="Comuna">Comuna</g:link>
            				</li>
            				<li class="controller">
            					<g:link controller="Region">Region</g:link>
            				</li>
            				<li class="controller">
            					<g:link controller="Estado">Estado</g:link>
            				</li>
            				<li class="controller">
            					<g:link controller="MedioDePago">MedioDePago</g:link>
            				</li>
            				<li class="controller">
            					<g:link controller="Direccion">Direccion</g:link>
            				</li>
            				<li class="controller">
            					<g:link controller="Servicio">Servicio</g:link>
            				</li>
            				<li class="controller">
            					<g:link controller="RegistroPago">RegistroPago</g:link>
            				</li>
            				<li class="controller">
            					<g:link controller="Mensaje">Mensaje</g:link>
            				</li>
            				<li class="controller">
            					<g:link controller="Conversacion">Conversacion</g:link>
            				</li>
            				<li class="controller">
            					<g:link controller="Trabajador">Trabajador</g:link>
            				</li>
            				<li class="controller">
                                <g:link controller="Contratacion">Contratacion</g:link>
                            </li>
                    </ul>
                </li>
            </content>
        <a href="#list-usuario" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
            </ul>
        </div>
        <div id="list-usuario" class="content scaffold-list" role="main">
            <h1><g:message code="default.list.label" args="[entityName]" /></h1>
            <g:if test="${flash.message}">
                <div class="message" role="status">${flash.message}</div>
            </g:if>
            <f:table collection="${usuarioList}" />

            <div class="pagination">
                <g:paginate total="${usuarioCount ?: 0}" />
            </div>
        </div>
    </body>
</html>

grails-app/views/usuario/show.gsp
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'usuario.label', default: 'Usuario')}" />
        <title><g:message code="default.show.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#show-usuario" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="list" action="index"><g:message code="default.list.label" args="[entityName]" /></g:link></li>
                <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
            </ul>
        </div>
        <div id="show-usuario" class="content scaffold-show" role="main">
            <h1><g:message code="default.show.label" args="[entityName]" /></h1>
            <g:if test="${flash.message}">
            <div class="message" role="status">${flash.message}</div>
            </g:if>
            <f:display bean="usuario" />
            <g:form resource="${this.usuario}" method="DELETE">
                <fieldset class="buttons">
                    <g:link class="edit" action="edit" resource="${this.usuario}"><g:message code="default.button.edit.label" default="Edit" /></g:link>
                    <input class="delete" type="submit" value="${message(code: 'default.button.delete.label', default: 'Delete')}" onclick="return confirm('${message(code: 'default.button.delete.confirm.message', default: 'Are you sure?')}');" />
                </fieldset>
            </g:form>
        </div>
    </body>
</html>

grails-app/views/usuario/showVersion2.gsp
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'usuario.label', default: 'Usuario')}" />
        <title><g:message code="default.show.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#show-usuario" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><g:link controller="Usuario" action="showVersion2">Perfil</g:link></li>
                <li><g:link controller="Contratacion" action="indexPorUsuario" params="[estado: "enProceso"]">Contrataciones pendientes</g:link></li>
                <li><g:link controller="Contratacion" action="indexPorUsuario" params="[estado: "terminada"]">Contrataciones finalizadas</g:link></li>
        </div>
        <div id="show-usuario" class="content scaffold-show" role="main">
            <h1>Perfil</h1>
            <g:if test="${flash.message}">
            <div class="message" role="status">${flash.message}</div>
            </g:if>
            <f:display bean="usuario" />
            <g:form resource="${this.usuario}" method="DELETE">
                <fieldset class="buttons">
                    <g:link class="edit" action="edit" resource="${this.usuario}">Modificar Perfil</g:link>
                    <input class="delete" type="submit" value="Eliminar Cuenta" onclick="return confirm('${message(code: 'default.button.delete.confirm.message', default: 'Are you sure?')}');" />
                </fieldset>
            </g:form>
        </div>
    </body>
</html>